<?php
/**
Plugin Name: CBD.how Blog API
Description: CBD.how Hemp Educational Blogs
Version: 1.0.2
Author: <a href="https://www.cbd.how" target="_blank">CBD.how</a>
License: GPLv2 or later
Text Domain: blog-api
*/

defined( 'ABSPATH' ) or die( 'No direct script please!' );

function installer(){
    include('installer.php');
}
register_activation_hook(__file__, 'installer');

function delete_tbl_from_db(){
    global $wpdb;
    $table_name = $wpdb->prefix . "custom_blog_settings";
    $wpdb->query("DROP TABLE IF EXISTS $table_name");
}
register_deactivation_hook(__FILE__, 'delete_tbl_from_db');


//V18QKJT-TCP4HGA-PP57S5M-ATKXB32

function cbd_how_blog_api_enqueue() {       
    // CSS
    wp_register_style('cbd_how_blog_api_bootstrap', 'https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css');
    wp_enqueue_style('cbd_how_blog_api_bootstrap');

    wp_register_style('cbd_how_blog_api_font_awsome', 'https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css');
    wp_enqueue_style('cbd_how_blog_api_font_awsome');
    if(isset($_GET['id']) &&  !empty($_GET['id'])){
        wp_register_style('cbd_how_blog_api_blog_page_detail',  plugins_url().'/blog-api/assets/css/blog_page_detail.css');
        wp_enqueue_style('cbd_how_blog_api_blog_page_detail');
    }else {
        wp_register_style('cbd_how_blog_api_blog_page',  plugins_url().'/blog-api/assets/css/blog_page.css');
        wp_enqueue_style('cbd_how_blog_api_blog_page');
    }
}
add_action( 'wp_print_styles', 'cbd_how_blog_api_enqueue');


function getUrlKey(){
    global $wpdb;
    $table_name = $wpdb->prefix . "custom_blog_settings";
    $authRes = $wpdb->get_results("SELECT auth_key FROM $table_name WHERE id =1");
    if($authRes[0]->auth_key){
        return $authRes[0]->auth_key;
    }else {
        return false;
    }
}

function curlGetData($url){
    $apiKey = getUrlKey();
    if($url == '' || !$apiKey){
        return false;
    }
    //$apiKey = 'V18QKJT-TCP4HGA-PP57S5M-ATKXB32'; 
    $headers = array(
        'API-KEY: '.$apiKey
    );
    $ch = curl_init($url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    $response = curl_exec($ch);
    $result = json_decode($response,true);
   // echo '<pre>'; print_r($result); exit;
    if($result['success'] == 1 && $result['status'] == 200){
        if($result['data']){
            return $result;
        }else {
            return "No Data Found";
        }
    }
    return false;
}



function getBlogsCategory($search = '') {
    ob_start();
    $keyword  = '';
    if(isset($_GET['search']) && $_GET['search'] !=''){
        $keyword = $_GET['search'];
        $keyword =  str_replace(' ', '%20', $keyword);
       // echo $keyword;
        $url = "https://api.cbd.vin/api/blogs?keyword=$keyword&page=1&perPage=10&sortBy=createdAt&sortOrder=-1";
    }else {
        if(isset($_GET['cat_id']) && $_GET['cat_id'] != ''){
            $cat_id = trim($_GET['cat_id']);
            $url = "https://api.cbd.vin/api/blogs?page=1&perPage=100&sortBy=createdAt&sortOrder=-1&categoryId=$cat_id";
        }else {
            $url = 'https://api.cbd.vin/api/blog-categories?page=1&perPage=100&sortBy=createdAt&sortOrder=-1&paginate=true&deleted=true&keyword='.$keyword.'';
        }
    }

    
    $result = curlGetData($url);
    //echo '<pre>'; print_r($result);exit;
    if($result){
        include('parse_html.php');
    }else {
        echo 'Please add your subscription key in plugin';
    }
    return ob_get_clean();
}
add_shortcode( 'get_blogs_categories', 'getBlogsCategory' );


function getSingleBlog( ) {
    $idTitle = trim($_GET['id']);
    $idTitleURL = explode("-", $idTitle);
    $id = end($idTitleURL); 
    $url = "https://api.cbd.vin/api/blogs/$id";
    //echo $url;exit;
    $result = curlGetData($url);
   // echo '<pre>'; print_r($result); exit;
    if($result){
        //echo  $result['data']['content'] ;exit;
        include('blog-detail.php');
      // include('parse_html.php');
    }else{
        echo 'Please check your API Keys';
    }
}
if(isset($_GET['id']) && $_GET['id'] != ''){
    add_shortcode( 'get_single_blog', 'getSingleBlog' );
}



// Register the menu
add_action( "admin_menu", "blog_api_plugin_menu_func" );
function blog_api_plugin_menu_func() {
    add_submenu_page(   "options-general.php",  // Which menu parent
                        "Blog",               // Page title
                        "CBD.how Blogs",               // Menu title
                        "manage_options",       // Minimum capability (manage_options is an easy way to target Admins)
                        "blog",               // Menu slug
                        "blog_api_plugin_options"     // Callback that prints the markup
                    );
}

// Print the markup for the page
function blog_api_plugin_options() {

    if ( !current_user_can( "manage_options" ) )  {
        wp_die( __( "You do not have sufficient permissions to access this page." ) );
    }

    
    global $wpdb;
    $table_name = $wpdb->prefix . "custom_blog_settings";
    $blog_results = $wpdb->get_results("SELECT * FROM $table_name");

    ?>
    <h2>Welcome to CBD.how Hemp Educational Plugin</h2>
    <p>Thank you for supporting our Educational Platform!</p>
    <h3>Directions</h3>
    <p>
    <p>1. Add your Blog API Subscription Key from <a href="https://my.cbd.vin/dashboard" target="_blank">https://my.cbd.vin/dashboard</a> below.</p>
    <p>2. Create a new page and title it “Education”.</p>
    <p>3. Add a shortcode and paste:  [get_blogs_categories]</p>
    <p>4. Save the page</p>
    </p>
    <!-- <form method="post" action="<?php echo admin_url( 'admin-post.php'); ?>">
    <?php
    if($blog_results[0]->id) { ?>
        <input type="hidden" name="id" value="<?php echo $blog_results[0]->id; ?>" />
    <?php
    }
    ?>
        <input type="hidden" name="action" value="update_blog_settings" />
        <h3><?php _e("Blog Info", "blog-api"); ?></h3>
        <p>
        <label><?php _e("Name:", "blog-api"); ?></label>
        <input class="" type="text" name="name" value="<?php if($blog_results[0]->name) { echo $blog_results[0]->name;  } ?>" />
        </p>

        <p>
        <label><?php _e("Email:", "blog-api"); ?></label>
        <input class="" type="text" name="email" value="<?php if($blog_results[0]->email) { echo $blog_results[0]->email;  } ?>" />
        </p>

        <input class="button button-primary" type="submit" value="<?php _e("Save", "blog-api"); ?>" />

    </form> -->
    <?php
    if ( isset($_GET['status']) && $_GET['status']=='success') { 
    ?>
        <div id="message" class="updated notice is-dismissible">
            <p><?php _e("Authentication Key Saved!", "blog-api"); ?></p>
            <button type="button" class="notice-dismiss">
                <span class="screen-reader-text"><?php _e("Dismiss this notice.", "blog-api"); ?></span>
            </button>
        </div>
    <?php
    }?>
    <form method="post" action="<?php echo admin_url( 'admin-post.php'); ?>">
    <?php
    if($blog_results[0]->id) { ?>
        <input type="hidden" name="id" value="<?php echo $blog_results[0]->id; ?>" />
    <?php
    }
    ?>
        <input type="hidden" name="action" value="oauth_submit" />
        <h3>Authentication</h3>
        <p>
            <label><?php _e("Blog API Key:", "blog-api"); ?></label>
            <input class="" type="text" name="auth_key" value="<?php if($blog_results[0]->auth_key) { echo $blog_results[0]->auth_key;  } ?>" />
        </p>
        <input class="button button-primary" type="submit" value="<?php _e("Authorize", "blog-api"); ?>" />
    </form>
    <br><br><br>
    <h3>Category List</h3>
    <?php
    $url = 'https://api.cbd.vin/api/blog-categories?page=1&perPage=100&sortBy=createdAt&sortOrder=-1&paginate=true&deleted=true&keyword=';
    $result = curlGetData($url);
    //echo '<pre>'; print_r($result); exit;
    ?>
    

<table class="widefat fixed" cellspacing="0">
    <tbody>
        <tr class="alternate">
            <th class="check-column" scope="row" style="width: 500px;"><strong>Title</strong></th>
            <td class="column-columnname" style="width: 500px;"><strong>Link</strong></td>
        </tr>
        <?php
      if(!empty($result['data'])) {
        foreach($result['data']['categories'] as $key => $res){
     ?>
        <tr>
            <th class="check-column" scope="row" style="width: 500px;"><?php echo $res['title'] ?></th>
            <td class="column-columnname" style="width: 500px;"><a href="<?php echo get_bloginfo('url');?>/education/?cat_id=<?php echo $res['_id'] ?>&t=<?php echo $res['title'] ?>" target="_blank"><?php echo $res['title'] ?></td>
           
        </tr>
        <?php }}else {?>
            <tr>
            <th class="check-column" scope="row">Not Found</th>
            <td class="column-columnname"></td>
        </tr>
    <?php } ?>
    </tbody>
</table>

<?php

}

add_action( 'admin_post_update_blog_settings', 'submitFormData' );

function submitFormData() {
    if($_SERVER["REQUEST_METHOD"] === "POST"){
        global $wpdb;
        $table_name = $wpdb->prefix . "custom_blog_settings";
        $data["name"] = trim(addslashes($_POST['name']));
        $data["email"] = trim(addslashes($_POST['email']));
        if(isset($_POST['id'])){
            $id = trim($_POST['id']);
            $wpdb->update($table_name, $data, array('id' => $id));
        }else{
            $wpdb->insert( $table_name, $data);
        }
       // wp_redirect( get_permalink() . 'options-general.php?page=blog&updated=true' );
       github_handle_save();
    }

}


add_action( 'admin_post_oauth_submit', 'handle_oauth' );

function handle_oauth() {
    if (!isset($_GET["code"]) && $_SERVER["REQUEST_METHOD"] === "POST") {
        if($_SERVER["REQUEST_METHOD"] === "POST"){
            global $wpdb;
            $table_name = $wpdb->prefix . "custom_blog_settings";
            $data["auth_key"] = trim(addslashes($_POST['auth_key']));
            if(isset($_POST['id'])){
                $id = trim($_POST['id']);
                $wpdb->update($table_name, $data, array('id' => $id));
            }else{
                $wpdb->insert( $table_name, $data);
            }
            
            wp_redirect( get_permalink() . 'options-general.php?page=blog&updated=true' );
        }
        github_handle_save();
    }

}

//add_action( 'admin_post_update_github_settings', 'github_handle_save' );

function github_handle_save() {

    $redirect_url = get_bloginfo("url") . "/wp-admin/options-general.php?page=blog&status=success";
    header("Location: ".$redirect_url);
    exit;
}